# Corporate Calendar Zope product
#
# By Peter Bengtsson, peter@fry-it.com,
# Fry-IT Ltd. London, 2004
# www.fry-it.com
# 
# See: zope.org/Members/malikz/CorpCalendar
#

import CorpCalendar

"""CorpCalendar Product"""


def initialize(context):
    """ Initialize IssueTracker product """
    try:
        context.registerClass(
            CorpCalendar.CorpCalendar,
            constructors = (
                # This is called when
                CorpCalendar.manage_addCorpCalendarForm,
                # someone adds the product
                CorpCalendar.manage_addCorpCalendar     
                ),
            icon = "www/calendar_icon.gif"

            )


        context.registerClass(
            CorpCalendar.CorpEvent,
            constructors = (
                # This is called when
                CorpCalendar.manage_addCorpEventForm,
                # someone adds the product
                CorpCalendar.manage_addCorpEvent     
                ),
            icon = "www/event_icon.gif"

            )

        registerIcon('home.gif')

##        context.registerHelp()
##        context.registerHelpTitle('IssueTrackerProduct Help')
    except:
        """If you can't register the product, tell someone. 
        
        Zope will sometimes provide you with access to "broken product" and
        a backtrace of what went wrong, but not always; I think that only 
        works for errors caught in your main product module. 
        
        This code provides traceback for anything that happened in 
        registerClass(), assuming you're running Zope in debug mode."""
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
        del type, val, tb




import OFS, App

def registerIcon(filename, idreplacer={}, epath=None):
    # A helper function that takes an image filename (assumed
    # to live in a 'www' subdirectory of this package). It 
    # creates an ImageFile instance and adds it as an attribute
    # of misc_.MyPackage of the zope application object (note
    # that misc_.MyPackage has already been created by the product
    # initialization machinery by the time registerIcon is called).
    objectid = filename
    if epath is not None:
        path = "www/%s/"%epath
    else:
        path = "www/"
    
    for k,v in idreplacer.items():
        objectid = objectid.replace(k,v)
    setattr(OFS.misc_.misc_.CorpCalendar, 
            objectid, 
            App.ImageFile.ImageFile('%s%s' % (path, filename), globals())
            )
